package {
    import flash.display.Loader;
    import flash.display.Sprite;
    import flash.display.StageAlign;
    import flash.display.StageScaleMode;
    import flash.events.Event;
    import flash.events.HTTPStatusEvent;
    import flash.events.IOErrorEvent;
    import flash.events.MouseEvent;
    import flash.events.SecurityErrorEvent;
    import flash.net.FileReference;
    import flash.net.URLLoader;
    import flash.net.URLLoaderDataFormat;
    import flash.net.URLRequest;

    public class FlickrViewerSample extends Sprite {
        
        private var urlLoader:URLLoader;
        private const FEED_URL:String = 'http://api.flickr.com/services/feeds/photos_public.gne?format=rss_200';
        
        public function FlickrViewerSample() {
            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;
            loadFlickrFeed();
        }
        
        private function loadFlickrFeed():void {
            urlLoader = new URLLoader();
            urlLoader.dataFormat = URLLoaderDataFormat.TEXT;
            urlLoader.load(new URLRequest(FEED_URL));
            urlLoader.addEventListener(Event.COMPLETE, loaded);
            
            urlLoader.addEventListener(HTTPStatusEvent.HTTP_STATUS, handleError);
            urlLoader.addEventListener(IOErrorEvent.IO_ERROR, handleError);
            urlLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, handleError);
        }
        
        private function loaded(e:Event):void {
            var feed:XML = XML(urlLoader.data);
            namespace mediaNS = 'http://search.yahoo.com/mrss/';
            use namespace mediaNS;
            for each(var item:XML in feed.channel.item) {
                var thumbnailUrl:String = item.thumbnail.@url;
                var width:uint = item.thumbnail.@width;
                var height:uint = item.thumbnail.@height;
                var contentUrl:String = item.content.@url;
                dispImage(thumbnailUrl, width, height, contentUrl);
            }
        }
        
        private function handleError(e:Event):void {
            // エラー時の処理(省略)
            trace(e);
        }
        
        private var count:int = 0;
        
        private function dispImage(imageUrl:String, width:uint, height:uint, contentUrl:String):void {
            var loader:Loader = new Loader();
            // ロード実行
            loader.load(new URLRequest(imageUrl));
            // 位置調整
            loader.x = count % 5 * width;
            loader.y = int(count / 5) * height;
            count++;
            this.addChild(loader);
            
            loader.doubleClickEnabled = true;
            loader.addEventListener(MouseEvent.DOUBLE_CLICK, function(e:Event):void {
                downloadImage(contentUrl);
            });
        }
        
        private function downloadImage(contentUrl:String):void {
            var fr:FileReference = new FileReference();
            fr.download(new URLRequest(contentUrl));
        }
    }
}
